package buildcraft.lib.client.resource;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.List;

import javax.annotation.Nullable;

import net.minecraft.client.Minecraft;
import net.minecraft.client.resources.IResource;
import net.minecraft.client.resources.IResourceManager;
import net.minecraft.client.resources.data.MetadataSerializer;
import net.minecraft.util.ResourceLocation;

/** Alternate metadata loader for {@link IResource#getMetadata(String)} */
public class MetadataLoader {

    private static boolean hasRegistered = false;

    private static void register() {
        if (!hasRegistered) {
            hasRegistered = true;
            MetadataSerializer metaReg = Minecraft.func_71410_x().func_110438_M().field_110621_c;
            metaReg.func_110504_a(DataMetadataSection.DESERIALISER, DataMetadataSection.class);
        }
    }

    /** @param samePack If true, then only the data
     * @return */
    @Nullable
    public static DataMetadataSection getData(ResourceLocation location, boolean samePack) {
        IResourceManager resManager = Minecraft.func_71410_x().func_110442_L();
        register();
        try {
            List<IResource> resources = resManager.func_135056_b(location);
            DataMetadataSection section = null;
            for (IResource resource : resources) {
                section = resource.func_110526_a(DataMetadataSection.SECTION_NAME);
                if (section != null || samePack) {
                    break;
                }
            }
            for (IResource res : resources) {
                try {
                    res.close();
                } catch (IOException io) {
                    io.printStackTrace();
                }
            }
            return section;
        } catch (FileNotFoundException fnfe) {
            // That's fine
            return null;
        } catch (IOException e) {
            // That's not fine
            e.printStackTrace();
            return null;
        }
    }
}
