/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.fluid;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.init.Blocks;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import net.minecraftforge.fluids.BlockFluidClassic;
import net.minecraftforge.fluids.Fluid;

public class BCFluidBlock extends BlockFluidClassic {
    private boolean sticky = false;

    public BCFluidBlock(Fluid fluid, Material material) {
        super(fluid, material);
        Boolean displaceWater = fluid.getDensity() > 1000;
        displacements.put(Blocks.field_150355_j, displaceWater);
        displacements.put(Blocks.field_150358_i, displaceWater);

        Boolean displaceLava = fluid.getDensity() > 9000;
        displacements.put(Blocks.field_150353_l, displaceLava);
        displacements.put(Blocks.field_150356_k, displaceLava);

        renderLayer = BlockRenderLayer.SOLID;
    }

    @Override
    public Boolean isEntityInsideMaterial(IBlockAccess world, BlockPos pos, IBlockState state, Entity entity, double yToTest, Material material, boolean testingHead) {
        if (material == Material.field_151586_h) {
            return true;
        }
        return null;
    }

    @Override
    public int getFlammability(IBlockAccess world, BlockPos pos, EnumFacing face) {
        return field_149764_J.func_76217_h() ? 200 : 0;
    }

    @Override
    public int getFireSpreadSpeed(IBlockAccess world, BlockPos pos, EnumFacing face) {
        return field_149764_J.func_76217_h() ? 200 : 0;
    }

    @Override
    public void func_180634_a(World worldIn, BlockPos pos, IBlockState state, Entity entityIn) {
        if (sticky) {
            entityIn.func_70110_aj();
        }
    }

    public void setSticky(boolean sticky) {
        this.sticky = sticky;
    }
}
