/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.misc;

import java.nio.ByteBuffer;

import org.lwjgl.BufferUtils;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL14;

import net.minecraft.client.Minecraft;

import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class GlUtil {
    private static ByteBuffer depthBuffer = null;

    public static void saveDepthBuffer() {
        Minecraft.func_71410_x().field_71424_I.func_76320_a("Save depth buffer");
        depthBuffer = BufferUtils.createByteBuffer(
            Minecraft.func_71410_x().field_71443_c
                * Minecraft.func_71410_x().field_71440_d
                * Float.BYTES
        );
        GL11.glReadPixels(
            0,
            0,
            Minecraft.func_71410_x().field_71443_c,
            Minecraft.func_71410_x().field_71440_d,
            GL11.GL_DEPTH_COMPONENT,
            GL11.GL_FLOAT,
            depthBuffer
        );
        Minecraft.func_71410_x().field_71424_I.func_76319_b();
    }

    public static void restoreDepthBuffer() {
        Minecraft.func_71410_x().field_71424_I.func_76320_a("Restore depth buffer");
        GL11.glColorMask(false, false, false, false);
        GL11.glRasterPos2i(0, 0);
        GL14.glWindowPos2i(0, 0);
        GL11.glDrawPixels(
            Minecraft.func_71410_x().field_71443_c,
            Minecraft.func_71410_x().field_71440_d,
            GL11.GL_DEPTH_COMPONENT,
            GL11.GL_FLOAT,
            depthBuffer
        );
        depthBuffer = null;
        GL11.glColorMask(true, true, true, true);
        Minecraft.func_71410_x().field_71424_I.func_76319_b();
    }
}
